unit ExprSampleCommon;

interface

uses System.Classes, System.SysUtils, Data.Bind.Components, FMX.Dialogs;

procedure ShowNotifyError(AObject: TObject; const AMessage: string);
procedure ShowExpressionError(AObject: TBindExpression; const AMessage: string);

implementation

resourcestring
  sNotifyError = 'Notify error.  Component %0:s, Message: %1:s';
  sExpressionError = 'Exception error.  Expression: ''%0:s'', Message: %1:s';

procedure ShowNotifyError(AObject: TObject; const AMessage: string);
var
  LName: string;
begin
  if AObject is TComponent then
    LName := TComponent(AObject).Name;
  if LName = '' then
    LName := AObject.ClassName;
  ShowMessage(Format(sNotifyError, [LName, AMessage]));
end;

procedure ShowExpressionError(AObject: TBindExpression; const AMessage: string);
begin
  ShowMessage(Format(sExpressionError, [AObject.SourceExpression, AMessage]));
end;

end.
